/// <reference types="./over-node.d.ts" />
import { freeze } from '../util/object-utils.js';
import { OrderByNode } from './order-by-node.js';
import { PartitionByNode } from './partition-by-node.js';
/**
 * @internal
 */
export const OverNode = freeze({
    is(node) {
        return node.kind === 'OverNode';
    },
    create() {
        return freeze({
            kind: 'OverNode',
        });
    },
    cloneWithOrderByItem(overNode, item) {
        return freeze({
            ...overNode,
            orderBy: overNode.orderBy
                ? OrderByNode.cloneWithItem(overNode.orderBy, item)
                : OrderByNode.create(item),
        });
    },
    cloneWithPartitionByItems(overNode, items) {
        return freeze({
            ...overNode,
            partitionBy: overNode.partitionBy
                ? PartitionByNode.cloneWithItems(overNode.partitionBy, items)
                : PartitionByNode.create(items),
        });
    },
});
